diff --git a/src/gui/macOS/QMPlay2MacExtensions.mm b/src/gui/macOS/QMPlay2MacExtensions.mm
index 02183c73..edeb8c94 100644
--- a/src/gui/macOS/QMPlay2MacExtensions.mm
+++ b/src/gui/macOS/QMPlay2MacExtensions.mm
@@ -1,69 +1,101 @@
 #include "QMPlay2MacExtensions.hpp"
 
-#include <QAbstractNativeEventFilter>
-#include <QGuiApplication>
-#include <QWindow>
+// Qt4 compatibility: Use QApplication instead of QGuiApplication
+#include <QApplication>
+#include <QWidget>
 
+// For media keys on macOS 10.6.8 with gcc (no blocks)
+#include <Carbon/Carbon.h>
 #include <IOKit/hidsystem/ev_keymap.h>
 #include <AppKit/NSApplication.h>
 #include <AppKit/NSScreen.h>
 #include <AppKit/NSEvent.h>
 
-class MediaKeysFilter : public QAbstractNativeEventFilter
+// Qt4 doesn't have QAbstractNativeEventFilter (Qt5.2+)
+// For macOS 10.6.8 with gcc (no blocks support), we use a polling-based approach
+// or carbon event handlers instead of Cocoa blocks
+
+// Forward declaration for the carbon event handler
+static OSStatus MediaKeysEventHandler(EventHandlerCallRef nextHandler, EventRef event, void *userData);
+
+class MediaKeysFilter : public QObject
 {
 public:
     MediaKeysFilter(const QMPlay2MacExtensions::MediaKeysCallback &cb) :
-        m_mediaKeysCallback(cb)
-    {}
-
-private:
-#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
-    bool nativeEventFilter(const QByteArray &eventType, void *message, qintptr *result) override final
-#else
-    bool nativeEventFilter(const QByteArray &eventType, void *message, long *result) override final
-#endif
+        m_mediaKeysCallback(cb),
+        m_eventHandlerRef(NULL)
+    {
+        // Use Carbon Event Manager for media keys support on 10.6.8 with gcc
+        // This doesn't require Apple blocks
+        EventTypeSpec eventTypes[1];
+        eventTypes[0].eventClass = kEventClassKeyboard;
+        eventTypes[0].eventKind = kEventHotKeyPressed;
+
+        InstallApplicationEventHandler(
+            NewEventHandlerUPP(MediaKeysEventHandler),
+            1,
+            eventTypes,
+            this,
+            &m_eventHandlerRef
+        );
+    }
+
+    ~MediaKeysFilter()
+    {
+        if (m_eventHandlerRef != NULL)
+        {
+            RemoveEventHandler(m_eventHandlerRef);
+            m_eventHandlerRef = NULL;
+        }
+    }
+
+    void handleMediaKey(int keyCode)
     {
-        Q_UNUSED(result)
-        if (eventType == "mac_generic_NSEvent")
+        switch (keyCode)
         {
-            NSEvent *event = static_cast<NSEvent *>(message);
-#if defined(MAC_OS_X_VERSION_10_12) && (MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_12)
-            if ([event type] == NSEventTypeSystemDefined)
-#else
-            if ([event type] == NSSystemDefined)
-#endif
-            {
-                const int  keyCode   = ([event data1] & 0xFFFF0000) >> 16;
-                const int  keyFlags  = ([event data1] & 0x0000FFFF);
-                const int  keyState  = (((keyFlags & 0xFF00) >> 8) == 0xA);
-                const bool keyRepeat = (keyFlags & 0x1);
-                Q_UNUSED(keyRepeat)
-
-                if (keyState == 1)
-                {
-                    switch (keyCode)
-                    {
-                        case NX_KEYTYPE_PLAY:
-                            m_mediaKeysCallback("toggle");
-                            return true;
-                        case NX_KEYTYPE_NEXT:
-                        case NX_KEYTYPE_FAST:
-                            m_mediaKeysCallback("next");
-                            return true;
-                        case NX_KEYTYPE_PREVIOUS:
-                        case NX_KEYTYPE_REWIND:
-                            m_mediaKeysCallback("prev");
-                            return true;
-                    }
-                }
-            }
+            case NX_KEYTYPE_PLAY:
+                m_mediaKeysCallback("toggle");
+                break;
+            case NX_KEYTYPE_NEXT:
+            case NX_KEYTYPE_FAST:
+                m_mediaKeysCallback("next");
+                break;
+            case NX_KEYTYPE_PREVIOUS:
+            case NX_KEYTYPE_REWIND:
+                m_mediaKeysCallback("prev");
+                break;
         }
-        return false;
     }
 
     QMPlay2MacExtensions::MediaKeysCallback m_mediaKeysCallback;
+    EventHandlerRef m_eventHandlerRef;
 } static *g_mediaKeysFilter;
 
+// Carbon event handler callback (no blocks needed)
+static OSStatus MediaKeysEventHandler(EventHandlerCallRef nextHandler, EventRef event, void *userData)
+{
+    Q_UNUSED(nextHandler)
+
+    MediaKeysFilter *filter = static_cast<MediaKeysFilter*>(userData);
+    if (!filter)
+        return eventNotHandledErr;
+
+    UInt32 eventClass = GetEventClass(event);
+    UInt32 eventKind = GetEventKind(event);
+
+    if (eventClass == kEventClassKeyboard && eventKind == kEventHotKeyPressed)
+    {
+        EventHotKeyID hotKeyID;
+        GetEventParameter(event, kEventParamDirectObject, typeEventHotKeyID, NULL, sizeof(hotKeyID), NULL, &hotKeyID);
+
+        // Handle media key based on hotKeyID
+        filter->handleMediaKey(hotKeyID.id);
+        return noErr;
+    }
+
+    return eventNotHandledErr;
+}
+
 /**/
 
 void QMPlay2MacExtensions::setApplicationVisible(bool visible)
@@ -80,29 +112,27 @@ void QMPlay2MacExtensions::registerMacOSMediaKeys(const MediaKeysCallback &cb)
     if (!g_mediaKeysFilter)
     {
         g_mediaKeysFilter = new MediaKeysFilter(cb);
-        QCoreApplication::instance()->installNativeEventFilter(g_mediaKeysFilter);
+        // Qt4 doesn't need installNativeEventFilter - Carbon events are handled directly
     }
 }
 void QMPlay2MacExtensions::unregisterMacOSMediaKeys()
 {
     if (g_mediaKeysFilter)
     {
-        QCoreApplication::instance()->removeNativeEventFilter(g_mediaKeysFilter);
         delete g_mediaKeysFilter;
         g_mediaKeysFilter = nullptr;
     }
 }
 
-void QMPlay2MacExtensions::showSystemUi(QWindow *mainWindow, bool visible)
+void QMPlay2MacExtensions::showSystemUi(QWidget *mainWindow, bool visible)
 {
-#if defined(MAC_OS_X_VERSION_10_9) && (MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_9)
-    if (mainWindow && mainWindow->screen() != QGuiApplication::primaryScreen() && ![NSScreen screensHaveSeparateSpaces])
-        return;
-#endif
-    unsigned long flags;
+    Q_UNUSED(mainWindow)
+    // macOS 10.6.8 doesn't have screensHaveSeparateSpaces (10.9+)
+    // Simplified for older macOS version
+    NSApplicationPresentationOptions flags;
     if (visible)
         flags = NSApplicationPresentationDefault;
     else
-        flags = NSApplicationPresentationHideDock | NSApplicationPresentationAutoHideMenuBar;
+        flags = (NSApplicationPresentationOptions)(NSApplicationPresentationHideDock | NSApplicationPresentationAutoHideMenuBar);
     [NSApp setPresentationOptions:flags];
 }
diff --git a/src/modules/ALSA/ALSA.hpp b/src/modules/ALSA/ALSA.hpp
index 5bbe407f..8a1b7b6b 100644
--- a/src/modules/ALSA/ALSA.hpp
+++ b/src/modules/ALSA/ALSA.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class ALSA final : public Module
+class ALSA : public Module
 {
 public:
     ALSA();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -39,13 +39,13 @@ class QDoubleSpinBox;
 class QCheckBox;
 class QComboBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *enabledB, *autoMultichnB;
     QDoubleSpinBox *delayB;
diff --git a/src/modules/ALSA/ALSAWriter.hpp b/src/modules/ALSA/ALSAWriter.hpp
index 9856b806..9310f13e 100644
--- a/src/modules/ALSA/ALSAWriter.hpp
+++ b/src/modules/ALSA/ALSAWriter.hpp
@@ -25,7 +25,7 @@
 
 struct _snd_pcm;
 
-class ALSAWriter final : public Writer
+class ALSAWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(ALSAWriter)
 public:
@@ -33,17 +33,17 @@ public:
 private:
     ~ALSAWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected);
+    qint64 write(const QByteArray &);
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/AudioCD/AudioCD.hpp b/src/modules/AudioCD/AudioCD.hpp
index 4ef8ea41..8739763f 100644
--- a/src/modules/AudioCD/AudioCD.hpp
+++ b/src/modules/AudioCD/AudioCD.hpp
@@ -24,19 +24,19 @@
 
 class CDIODestroyTimer;
 
-class AudioCD final : public Module
+class AudioCD : public Module
 {
     Q_OBJECT
 public:
     AudioCD();
     ~AudioCD();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    QList<QAction *> getAddActions() override;
+    QList<QAction *> getAddActions();
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
     QIcon CD;
 
@@ -52,13 +52,13 @@ class QGridLayout;
 class QGroupBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QGroupBox *audioCDB;
     QCheckBox *useCDDB, *useCDTEXT;
diff --git a/src/modules/AudioCD/AudioCDDemux.cpp b/src/modules/AudioCD/AudioCDDemux.cpp
index 5fa6202d..31559f16 100644
--- a/src/modules/AudioCD/AudioCDDemux.cpp
+++ b/src/modules/AudioCD/AudioCDDemux.cpp
@@ -22,9 +22,9 @@
 #include <Packet.hpp>
 
 #ifdef Q_OS_WIN
-    #include <QRegularExpression>
+    #include <QRegExp>
     #include <QDir>
-    static const QRegularExpression cdaRegExp(R"(file:\/\/\D:\/track\d\d.cda)");
+    static const QRegExp cdaRegExp("file://\\D:/track\\d\\d.cda");
 #endif
 
 #define CD_BLOCKSIZE 2352/2
diff --git a/src/modules/AudioCD/AudioCDDemux.hpp b/src/modules/AudioCD/AudioCDDemux.hpp
index 5ea6d362..fa4bf616 100644
--- a/src/modules/AudioCD/AudioCDDemux.hpp
+++ b/src/modules/AudioCD/AudioCDDemux.hpp
@@ -26,7 +26,7 @@
 #include <cdio/cdio.h>
 #include <cddb/cddb.h>
 
-class CDIODestroyTimer final : public QObject
+class CDIODestroyTimer : public QObject
 {
     Q_OBJECT
 public:
@@ -38,7 +38,7 @@ public:
 private slots:
     void setInstanceSlot(CdIo_t *_cdio, const QString &_device, unsigned _discID);
 private:
-    void timerEvent(QTimerEvent *e) override;
+    void timerEvent(QTimerEvent *e);
 
     QAtomicInt timerId;
     CdIo_t *cdio;
@@ -48,7 +48,7 @@ private:
 
 /**/
 
-class AudioCDDemux final : public Demuxer
+class AudioCDDemux : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(AudioCDDemux)
 public:
@@ -58,21 +58,21 @@ public:
 private:
     ~AudioCDDemux();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    QList<QMPlay2Tag> tags() const;
+    double length() const;
+    int bitrate() const;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int & ) override;
-    void abort() override;
+    bool seek(double, bool);
+    bool read(Packet &, int & );
+    void abort();
 
-    bool open(const QString &) override;
+    bool open(const QString &);
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok);
 
     /**/
 
diff --git a/src/modules/AudioFilters/AVAudioFilter.cpp b/src/modules/AudioFilters/AVAudioFilter.cpp
index 3ab46f56..c6e44577 100644
--- a/src/modules/AudioFilters/AVAudioFilter.cpp
+++ b/src/modules/AudioFilters/AVAudioFilter.cpp
@@ -143,7 +143,11 @@ double AVAudioFilter::filter(QByteArray &data, bool flush)
         if (av_buffersink_get_frame(m_filtOut, m_frameOut) == 0)
         {
             const int n = m_frameOut->nb_samples * m_chn * sizeof(float);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             m_bufferedSamples = (qintptr)m_frameIn->opaque - (qintptr)m_frameOut->opaque;
+#else
+            m_bufferedSamples = (qint64)m_frameIn->opaque - (qint64)m_frameOut->opaque;
+#endif
             delay = static_cast<double>(m_bufferedSamples) / static_cast<double>(m_srate);
             if (n == data.size())
             {
@@ -218,7 +222,7 @@ bool AVAudioFilter::ensureFilters()
         }
         m_filterGraph = avfilter_graph_alloc();
 
-        const auto argsIn = QStringLiteral("sample_rate=%1:sample_fmt=flt:channel_layout=%2").arg(m_srate).arg(chnLayout.constData()).toLatin1();
+        const auto argsIn = QString("sample_rate=%1:sample_fmt=flt:channel_layout=%2").arg(m_srate).arg(chnLayout.constData()).toLatin1();
         if (avfilter_graph_create_filter(&m_filtIn, avfilter_get_by_name("abuffer"), "in", argsIn, nullptr, m_filterGraph) < 0)
         {
             qWarning() << "AVAudioFilter :: Can't create in filter";
@@ -226,7 +230,7 @@ bool AVAudioFilter::ensureFilters()
         }
 
 #if LIBAVFILTER_VERSION_INT >= AV_VERSION_INT(11, 4, 100)
-        const auto argsOut = QStringLiteral("samplerates=%1:sample_formats=flt:channel_layouts=%2").arg(m_srate).arg(chnLayout.constData()).toLatin1();
+        const auto argsOut = QString("samplerates=%1:sample_formats=flt:channel_layouts=%2").arg(m_srate).arg(chnLayout.constData()).toLatin1();
 #else
         const char *argsOut = nullptr;
 #endif
diff --git a/src/modules/AudioFilters/AVAudioFilter.hpp b/src/modules/AudioFilters/AVAudioFilter.hpp
index 8a3077c5..22dbba93 100644
--- a/src/modules/AudioFilters/AVAudioFilter.hpp
+++ b/src/modules/AudioFilters/AVAudioFilter.hpp
@@ -25,7 +25,7 @@ struct AVFilterGraph;
 struct AVFilterInOut;
 struct AVFrame;
 
-class AVAudioFilter final : public AudioFilter
+class AVAudioFilter : public AudioFilter
 {
 public:
     static QStringList getAvailableFilters();
@@ -36,13 +36,13 @@ public:
     AVAudioFilter(Module &module);
     ~AVAudioFilter();
 
-    bool set() override;
+    bool set();
 
 private:
-    bool setAudioParameters(uchar chn, uint srate) override;
-    int bufferedSamples() const override;
-    void clearBuffers() override;
-    double filter(QByteArray &data, bool flush) override;
+    bool setAudioParameters(uchar chn, uint srate);
+    int bufferedSamples() const;
+    void clearBuffers();
+    double filter(QByteArray &data, bool flush);
 
 private:
     inline void setCanFilter();
@@ -71,7 +71,11 @@ private:
     AVFrame *m_frameIn = nullptr;
     AVFrame *m_frameOut = nullptr;
 
+#if QT_VERSION >= 0x050000
     qintptr m_overallSamples = 0;
+#else
+    qint64 m_overallSamples = 0;
+#endif
     int m_bufferedSamples = 0;
 
     bool m_paramsChanged = false;
diff --git a/src/modules/AudioFilters/AudioFilters.cpp b/src/modules/AudioFilters/AudioFilters.cpp
index 102e7550..8cb09e14 100644
--- a/src/modules/AudioFilters/AudioFilters.cpp
+++ b/src/modules/AudioFilters/AudioFilters.cpp
@@ -349,16 +349,21 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
     m_avAudioFilterB = new QGroupBox(tr("FFmpeg audio filters"));
     m_avAudioFilterB->setCheckable(true);
     m_avAudioFilterB->setChecked(sets().getBool("AVAudioFilter"));
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(m_avAudioFilterB, &QGroupBox::toggled, this, [this](bool checked) {
         sets().set("AVAudioFilter", checked);
         SetInstance<AVAudioFilter>();
     });
+#else
+    connect(m_avAudioFilterB, SIGNAL(toggled(bool)), this, SLOT(avAudioFilterToggled(bool)));
+#endif
 
     auto audioFiltersInfoB = new QToolButton;
     audioFiltersInfoB->setText("?");
     audioFiltersInfoB->setToolTip(tr("Help"));
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(audioFiltersInfoB, &QToolButton::clicked, this, [this] {
-        const auto sep = QStringLiteral("<br/>&nbsp;&nbsp;&nbsp;");
+        const auto sep = QString("<br/>&nbsp;&nbsp;&nbsp;");
         auto te = new QTextBrowser(window());
         te->setWindowFlag(Qt::Window);
         te->setOpenExternalLinks(true);
@@ -369,16 +374,20 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
                "To use some filters like '%4', you need to enable \"force channels conversion\" and \"use channel conversion before filters\" in playback settings. "
                "Please refer to the %1FFmpeg documentation%2.%3Available audio filters:"
               )
-                .arg(QStringLiteral("<a href='https://ffmpeg.org/ffmpeg-filters.html#Audio-Filters'>"), QStringLiteral("</a>"), QStringLiteral("<br/><br/>"), "surround")
+                .arg(QString("<a href='https://ffmpeg.org/ffmpeg-filters.html#Audio-Filters'>"), QString("</a>"), QString("<br/><br/>"), "surround")
                 + sep + AVAudioFilter::getAvailableFilters().join(sep)
         );
         te->show();
     });
+#else
+    connect(audioFiltersInfoB, SIGNAL(clicked()), this, SLOT(audioFiltersInfo()));
+#endif
 
     m_avAudioFilterE = new QLineEdit;
     m_avAudioFilterE->setPlaceholderText(
-        tr("FFmpeg audio filters, example: %1").arg(QStringLiteral("volume=0.6,extrastereo"))
+        tr("FFmpeg audio filters, example: %1").arg(QString("volume=0.6,extrastereo"))
     );
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(m_avAudioFilterE, &QLineEdit::textChanged, this, [this](const QString &text) {
         const bool ok = AVAudioFilter::validateFilters(text.toLatin1().trimmed());
         auto font = m_avAudioFilterE->font();
@@ -390,6 +399,9 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
             SetInstance<AVAudioFilter>();
         }
     });
+#else
+    connect(m_avAudioFilterE, SIGNAL(textChanged(QString)), this, SLOT(avAudioFilterTextChanged(QString)));
+#endif
     m_avAudioFilterE->setText(sets().getByteArray("AVAudioFilter/Filters"));
 
     auto avAudioFilterLayout = new QHBoxLayout(m_avAudioFilterB);
@@ -529,3 +541,43 @@ void ModuleSettingsWidget::saveSettings()
     sets().set("Equalizer/minFreq", eqMinFreqB->value());
     sets().set("Equalizer/maxFreq", eqMaxFreqB->value());
 }
+
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0) && defined(USE_AVAUDIOFILTER)
+void ModuleSettingsWidget::avAudioFilterToggled(bool checked)
+{
+    sets().set("AVAudioFilter", checked);
+    SetInstance<AVAudioFilter>();
+}
+
+void ModuleSettingsWidget::audioFiltersInfo()
+{
+    const auto sep = QString("<br/>&nbsp;&nbsp;&nbsp;");
+    auto te = new QTextBrowser(window());
+    te->setWindowFlags(te->windowFlags() | Qt::Window);
+    te->setOpenExternalLinks(true);
+    te->setAttribute(Qt::WA_DeleteOnClose);
+    te->setWindowTitle(m_avAudioFilterB->title());
+    te->setHtml(
+        tr("Not all audio filters are supported in QMPlay2. "
+           "To use some filters like '%4', you need to enable \"force channels conversion\" and \"use channel conversion before filters\" in playback settings. "
+           "Please refer to the %1FFmpeg documentation%2.%3Available audio filters:"
+          )
+            .arg(QString("<a href='https://ffmpeg.org/ffmpeg-filters.html#Audio-Filters'>"), QString("</a>"), QString("<br/><br/>"), "surround")
+            + sep + AVAudioFilter::getAvailableFilters().join(sep)
+    );
+    te->show();
+}
+
+void ModuleSettingsWidget::avAudioFilterTextChanged(const QString &text)
+{
+    const bool ok = AVAudioFilter::validateFilters(text.toLatin1().trimmed());
+    auto font = m_avAudioFilterE->font();
+    font.setUnderline(!ok);
+    m_avAudioFilterE->setFont(font);
+    if (ok)
+    {
+        sets().set("AVAudioFilter/Filters", m_avAudioFilterE->text().toLatin1());
+        SetInstance<AVAudioFilter>();
+    }
+}
+#endif
diff --git a/src/modules/AudioFilters/AudioFilters.hpp b/src/modules/AudioFilters/AudioFilters.hpp
index f0b18ae4..436a2bca 100644
--- a/src/modules/AudioFilters/AudioFilters.hpp
+++ b/src/modules/AudioFilters/AudioFilters.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class AudioFilters final : public Module
+class AudioFilters : public Module
 {
 public:
     AudioFilters();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -42,7 +42,7 @@ class QLineEdit;
 class QSpinBox;
 class Slider;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -55,8 +55,13 @@ private slots:
     void echo();
     void compressor();
     void defaultSettings();
+#if QT_VERSION < 0x050000 && defined(USE_AVAUDIOFILTER)
+    void avAudioFilterToggled(bool checked);
+    void audioFiltersInfo();
+    void avAudioFilterTextChanged(const QString &text);
+#endif
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     bool restoringDefault;
 
diff --git a/src/modules/AudioFilters/BS2B.hpp b/src/modules/AudioFilters/BS2B.hpp
index 92a3c44e..3260b1b1 100644
--- a/src/modules/AudioFilters/BS2B.hpp
+++ b/src/modules/AudioFilters/BS2B.hpp
@@ -22,17 +22,17 @@
 
 #include <bs2b/bs2b.hpp>
 
-class BS2B final : public AudioFilter
+class BS2B : public AudioFilter
 {
 public:
     BS2B(Module &module);
     ~BS2B();
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint srate) override;
-    void clearBuffers() override;
-    double filter(QByteArray &data, bool flush) override;
+    bool setAudioParameters(uchar, uint srate);
+    void clearBuffers();
+    double filter(QByteArray &data, bool flush);
 
     void alloc();
 
diff --git a/src/modules/AudioFilters/DysonCompressor.hpp b/src/modules/AudioFilters/DysonCompressor.hpp
index 63b4fe68..20caa6f5 100644
--- a/src/modules/AudioFilters/DysonCompressor.hpp
+++ b/src/modules/AudioFilters/DysonCompressor.hpp
@@ -25,19 +25,19 @@
 #define NFILT  12
 #define NEFILT 17
 
-class DysonCompressor final : public AudioFilter
+class DysonCompressor : public AudioFilter
 {
 public:
     DysonCompressor(Module &module);
     ~DysonCompressor();
 
-    bool set() override;
+    bool set();
 
 private:
-    bool setAudioParameters(uchar chn, uint srate) override;
-    int bufferedSamples() const override;
-    void clearBuffers() override;
-    double filter(QByteArray &data, bool flush) override;
+    bool setAudioParameters(uchar chn, uint srate);
+    int bufferedSamples() const;
+    void clearBuffers();
+    double filter(QByteArray &data, bool flush);
 
     using FloatVector = QVector<float>;
 
diff --git a/src/modules/AudioFilters/Echo.hpp b/src/modules/AudioFilters/Echo.hpp
index 62a9c8d1..37bbae11 100644
--- a/src/modules/AudioFilters/Echo.hpp
+++ b/src/modules/AudioFilters/Echo.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class Echo final : public AudioFilter
+class Echo : public AudioFilter
 {
 public:
     Echo(Module &);
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(QByteArray &, bool) override;
+    bool setAudioParameters(uchar, uint);
+    double filter(QByteArray &, bool);
 
     void alloc(bool);
 
diff --git a/src/modules/AudioFilters/Equalizer.cpp b/src/modules/AudioFilters/Equalizer.cpp
index 09a0f6eb..d75be492 100644
--- a/src/modules/AudioFilters/Equalizer.cpp
+++ b/src/modules/AudioFilters/Equalizer.cpp
@@ -65,6 +65,9 @@ float Equalizer::getAmpl(int val)
 }
 
 Equalizer::Equalizer(Module &module)
+#if QT_VERSION < QT_VERSION_CHECK(5, 14, 0)
+    : m_mutex(QMutex::Recursive)
+#endif
 {
     SetModule(module);
 }
diff --git a/src/modules/AudioFilters/Equalizer.hpp b/src/modules/AudioFilters/Equalizer.hpp
index 59aae7f0..7889cf64 100644
--- a/src/modules/AudioFilters/Equalizer.hpp
+++ b/src/modules/AudioFilters/Equalizer.hpp
@@ -21,9 +21,15 @@
 #include <AudioFilter.hpp>
 #include <FFT.hpp>
 
+#if QT_VERSION >= 0x050E00
+    #include <QRecursiveMutex>
+#else
+    #include <QMutex>
+#endif
+
 #include <vector>
 
-class Equalizer final : public AudioFilter
+class Equalizer : public AudioFilter
 {
 public:
     static QVector<float> interpolate(const QVector<float> &, const int);
@@ -33,12 +39,12 @@ public:
     Equalizer(Module &);
     ~Equalizer();
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint) override;
-    int bufferedSamples() const override;
-    void clearBuffers() override;
-    double filter(QByteArray &data, bool flush) override;
+    bool setAudioParameters(uchar, uint);
+    int bufferedSamples() const;
+    void clearBuffers();
+    double filter(QByteArray &data, bool flush);
 
     /**/
 
@@ -56,7 +62,11 @@ private:
     bool m_hasParameters = false;
     bool m_enabled = false;
 
+#if QT_VERSION >= 0x050E00
     mutable QRecursiveMutex m_mutex;
+#else
+    mutable QMutex m_mutex;
+#endif
     FFT m_fftIn;
     FFT m_fftOut;
     FFT::Complex *m_complex = nullptr;
diff --git a/src/modules/AudioFilters/EqualizerGUI.cpp b/src/modules/AudioFilters/EqualizerGUI.cpp
index a25b02b2..ecbd3fbf 100644
--- a/src/modules/AudioFilters/EqualizerGUI.cpp
+++ b/src/modules/AudioFilters/EqualizerGUI.cpp
@@ -342,7 +342,7 @@ void EqualizerGUI::setSliders()
 {
     const QString objectName = sender()->objectName();
     graph.hide();
-    for (QSlider *slider : std::as_const(sliders))
+    for (QSlider *slider : sliders)
     {
         const bool isPreamp = (sliders.at(0) == slider);
 
@@ -377,7 +377,7 @@ void EqualizerGUI::addPreset()
         }
 
         QMap<int, int> values;
-        for (QSlider *slider : std::as_const(sliders))
+        for (QSlider *slider : sliders)
         {
             const bool isPreamp = (sliders.at(0) == slider);
             if (isPreamp)
@@ -432,7 +432,7 @@ void EqualizerGUI::setPresetValues()
         QMap<int, int> values = getPresetValues(act->text());
         if (values.count() > 1)
         {
-            for (QSlider *slider : std::as_const(sliders))
+            for (QSlider *slider : sliders)
             {
                 QCheckBox *checkB = getSliderCheckBox(slider);
                 const bool isPreamp = (sliders.at(0) == slider);
diff --git a/src/modules/AudioFilters/EqualizerGUI.hpp b/src/modules/AudioFilters/EqualizerGUI.hpp
index e7ca95ad..58609ad5 100644
--- a/src/modules/AudioFilters/EqualizerGUI.hpp
+++ b/src/modules/AudioFilters/EqualizerGUI.hpp
@@ -20,7 +20,7 @@
 
 #include <QMPlay2Extensions.hpp>
 
-class GraphW final : public QWidget
+class GraphW : public QWidget
 {
 public:
     GraphW();
@@ -31,7 +31,7 @@ public:
         values.resize(vals);
     }
 private:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *);
 
     QVector<float> values;
     float preamp;
@@ -44,15 +44,15 @@ class QCheckBox;
 class QSlider;
 class QMenu;
 
-class EqualizerGUI final : public QWidget, public QMPlay2Extensions
+class EqualizerGUI : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 public:
     EqualizerGUI(Module &);
 
-    bool set() override;
+    bool set();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 private slots:
     void wallpaperChanged(bool hasWallpaper, double alpha);
     void enabled(bool);
@@ -80,7 +80,7 @@ private:
 
     void loadPresets();
 
-    void showEvent(QShowEvent *event) override;
+    void showEvent(QShowEvent *event);
 
     QMap<int, int> getPresetValues(const QString &name);
 
diff --git a/src/modules/AudioFilters/PhaseReverse.hpp b/src/modules/AudioFilters/PhaseReverse.hpp
index 1ad382b8..6ff1d469 100644
--- a/src/modules/AudioFilters/PhaseReverse.hpp
+++ b/src/modules/AudioFilters/PhaseReverse.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class PhaseReverse final : public AudioFilter
+class PhaseReverse : public AudioFilter
 {
 public:
     PhaseReverse(Module &);
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(QByteArray &, bool) override;
+    bool setAudioParameters(uchar, uint);
+    double filter(QByteArray &, bool);
 
     bool enabled, hasParameters, canFilter, reverseRight;
     uchar chn;
diff --git a/src/modules/AudioFilters/SwapStereo.hpp b/src/modules/AudioFilters/SwapStereo.hpp
index 259ea912..d6786f35 100644
--- a/src/modules/AudioFilters/SwapStereo.hpp
+++ b/src/modules/AudioFilters/SwapStereo.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class SwapStereo final : public AudioFilter
+class SwapStereo : public AudioFilter
 {
 public:
     SwapStereo(Module &);
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(QByteArray &, bool) override;
+    bool setAudioParameters(uchar, uint);
+    double filter(QByteArray &, bool);
 
     bool m_enabled = false, m_hasParameters = false, m_canFilter = false;
     uchar m_chn = 0;
diff --git a/src/modules/AudioFilters/VoiceRemoval.hpp b/src/modules/AudioFilters/VoiceRemoval.hpp
index 60b1f66e..35190aaa 100644
--- a/src/modules/AudioFilters/VoiceRemoval.hpp
+++ b/src/modules/AudioFilters/VoiceRemoval.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class VoiceRemoval final : public AudioFilter
+class VoiceRemoval : public AudioFilter
 {
 public:
     VoiceRemoval(Module &);
 
-    bool set() override;
+    bool set();
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(QByteArray &, bool) override;
+    bool setAudioParameters(uchar, uint);
+    double filter(QByteArray &, bool);
 
     bool enabled, hasParameters, canFilter;
     uchar chn;
diff --git a/src/modules/CUVID/Cuvid.hpp b/src/modules/CUVID/Cuvid.hpp
index 1442fc45..6861cf3e 100644
--- a/src/modules/CUVID/Cuvid.hpp
+++ b/src/modules/CUVID/Cuvid.hpp
@@ -24,7 +24,7 @@
 
 class QComboBox;
 
-class Cuvid final : public Module
+class Cuvid : public Module
 {
     Q_DECLARE_TR_FUNCTIONS(Cuvid)
 
@@ -33,12 +33,12 @@ public:
     ~Cuvid();
 
 private:
-    QList<Info> getModulesInfo(const bool showDisabled) const override;
-    void *createInstance(const QString &name) override;
+    QList<Info> getModulesInfo(const bool showDisabled) const;
+    void *createInstance(const QString &name);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
-    void videoDeintSave() override;
+    void videoDeintSave();
 
     /**/
 
@@ -58,7 +58,7 @@ public:
     ModuleSettingsWidget(Module &module);
 
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *m_enabledB, *m_decodeMPEG4;
 #ifdef Q_OS_WIN
